
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.ArrayList;


public class AirportController {
    private ArrayList <Pilot> allPilots;

    public AirportController() {
        this.allPilots = new ArrayList<>();
    }

    public void centralDefinition() {
        // Založte první Letiště (Airport)
        Airport airport1 = new Airport(1, "Prague");
        // Založte druhé letiště (Airport)
        Airport airport2 = new Airport(2, "Brno");
        // Založte první letadlo (Airplane)
        Airplane airplane = new Airplane(1000,AirplaneType.BOEING_737_MAX, 2015);
        // Založte druhé letadlo (Airplane)
        Airplane airplane2 = new Airplane(1001,AirplaneType.BOEING_737, 2009);
        // Založte prvního pilota (Pilot) a přidejte ho do systému
        Pilot pilot1 = new Pilot(10000,"Pavel",1990,2016);
        this.allPilots.add(pilot1);
        // Založte druhého pilota (Pilot) a přidejte ho do systému
        Pilot pilot2 = new Pilot(10001,"Petr",1982,2008);
        this.allPilots.add(pilot2);
        // Založte třetího pilota (Pilot) a přidejte ho do systému
        Pilot pilot3 = new Pilot(10002,"Adéla",1986,2018);
        this.allPilots.add(pilot3);
        // Založte třetího pilota (Pilot) a přidejte ho do systému
        Pilot pilot4 = new Pilot(10003,"Marek",1988,2019);
        this.allPilots.add(pilot4);
        //Přiřaď prvním dvěma pilotům certifikaci na letadlo "BOEING_737"
        pilot1.setCertification(AirplaneType.BOEING_737);
        pilot2.setCertification(AirplaneType.BOEING_737);
        //Přiřaď druhým dvěma pilotům certifikaci na letadlo "BOEING_737_MAX"
        pilot3.setCertification(AirplaneType.BOEING_737_MAX);
        pilot4.setCertification(AirplaneType.BOEING_737_MAX);
        // Založte let (Flight)
        LocalDate date = LocalDate.of(2020,8,9);
        LocalTime time = LocalTime.of(20,50);
        Flight flight = new Flight(700, "AB700", LocalDateTime.of(date, time),  airplane, airport1, airport2, 0,35);
        Flight flight2 = new Flight(701, "AB701", LocalDateTime.of(date, time),  airplane2, airport1, airport2, 0,35);


        // Pro všechny piloty v systému zkontrolujte jejich certifikaci
        // a pokud mají certifikaci na letadlo, které letí na letu s instancí "flight",
        // vyberte počet pilotů na letu ("numberOfPilotsAtFlight"), kteří budou pilotovat let
        choosePilotWithLicenceToFlight(flight, 2);
        choosePilotWithLicenceToFlight(flight2, 2);

        System.out.println("Na letu 1 letí piloti:");
        System.out.println(flight.getPilotsNameOnFlight());
        System.out.println("Na letu 2 letí piloti:");
        System.out.println(flight2.getPilotsNameOnFlight());


    }

    public void choosePilotWithLicenceToFlight(Flight flight, int numberOfPilotsAtFlight)
    {
        // Projdi všechny existující piloty
        for (Pilot onePilot: allPilots)
        {
            // Pokud má pilot certifikaci k letadlu na letu
            // MÁTE NAIMPLEMENTOVAT FUNKCI isPilotCertificatedOn, která vrací buď True nebo False
            if (onePilot.isPilotCertificatedOn(flight.getAirplane().getAirplaneType()))
            {
                // K letu pak přiřazuji pilota
                flight.addPilotToFlight(onePilot);

                // Počet pilotů, které hledám, zmenším o 1
                numberOfPilotsAtFlight--;

                // Když už jsme našli dva piloty, tak ukončíme hledání
                if (numberOfPilotsAtFlight < 1)
                    break;
            }
        }
    }
}
